rays = {}

function rays:load()
    self.x1 = Player.x + Player.w/2
    self.y1 = Player.y + Player.h/2
    -- length of the ray
    self.const = 100
    self.x2 = self.const * math.cos(Player.rotAngle) + self.x1
    self.y2 = self.const * math.sin(Player.rotAngle) + self.y1
    self.isRays = true
    self.filter = function(item)
        --ignores player but recognizes walls
        if     item.isWall   then return 'slide'
        elseif item.isPlayer then return nil
        end
    end
end


function rays:update(dt)
    self.x1 = Player.x + 0.5*Player.w
    self.y1 = Player.y + 0.5*Player.h
    self.x2 = self.const * math.cos(Player.rotAngle) + self.x1
    self.y2 = self.const * math.sin(Player.rotAngle) + self.y1

    -- collision query for segment: the world query segment will always be length 100 
    local itemInfo, len = world:querySegmentWithCoords(self.x1 + Player.w/2, self.y1, 100 * math.cos(Player.rotAngle) + self.x1, 100 * math.cos(Player.rotAngle) + self.y1, self.filter)

    for i = 1, len do
        local thing = itemInfo[i]
        -- if collision is detected, then self.const will be adjusted to the distance between the center and the collision coordinates
        if thing.x2 and thing.y2 then
            self.const = math.sqrt((thing.x2 - self.x1)^2 + (thing.y2 - self.y1)^2)
        else
        -- or else it will go back to being 100    
            self.const = 100
        end
        
    end

end

function rays:draw()
    love.graphics.line(self.x1, self.y1, self.x2, self.y2)
    print(self.const)
end